#! /usr/bin/python

## testHTKAMBuilder.py
## Copyright (C) 2007 Ivan Uemlianin
## Contact: ivan@llaisdy.com
## 
## This file is part of Trefnydd.
##
## Trefnydd is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## Trefnydd is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with Trefnydd (i.e., doc/gpl.txt); if not, write to the Free Software
## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
## or see http://www.gnu.org/licenses/gpl.txt


"""
========
trefnydd
========

Package:   trefnydd
Module:    testHTKAMBuilder
Copyright: 2007 Ivan A. Uemlianin
Contact:   ivan@llaisdy.com
Licence:   GNU GPL (see doc/gpl.txt)

testHTKAMBuilder
================

"""


import os, sys
trefnydd_root = os.path.dirname(os.path.dirname(os.getcwd()))
if trefnydd_root not in sys.path:
    sys.path.append(trefnydd_root)

import unittest

from trefnydd.utils import file_IO
from trefnydd.lib import corpus
from trefnydd.lib.ambuilder import ambuilder


def getCorpus():
    c = corpus.SpeechCorpus()
    c.homeDir = 'amser'
    c.importData() # phone labels
##     c.importData('lll_tiny') # word labels
    return c
    

class HTKAMBuilderTests(unittest.TestCase):

    def setUp(self):
        self.hab = ambuilder.HTKAMBuilder(True)
        self.hab.homeDir = 'htkTest'
        self.hab.corpus = getCorpus()
        self.hab.labelType = 'Phone'
        self.hab.setup()
        # self.hab.extractFeatures() # or have mfc files ready
        self.hab.defineModelParameters() # or have hmm1 ready

    def tearDown(self):
        self.hab.cleanup(['lab', 'wav'])

##     # working 070503
##     def testHTKAMBuilderSetup(self):
##         self.failUnless(self.hab.setup() == None)
##         self.failUnless(os.getcwd() == self.hab.homeDir)


##     # working 070503
##     def testHTKAMBuilderFeatExt(self):
##         self.failUnless(self.hab.extractFeatures() == None)

##     # working 070504
##     def testHTKAMBuilderModelDefinition(self):
##         self.failUnless(self.hab.defineModelParameters() == None)

##     # working 070506
##     def testHTKAMBuilderTrain(self):
##         self.failUnless(self.hab.trainModel() == None)

##     # working 070506
##     def testCleanup(self):
##         self.failUnless(self.hab.cleanup(['lab', 'wav']) == None)

## # 070506 build model working!


def main(debug):
    unittest.main()
##     testme()

def testme():
    hab = ambuilder.HTKAMBuilder()
    hab.homeDir = 'htkTest'
    hab.corpus = getCorpus()
    hab.labelType = 'Word'
    hab.setup()
    

if __name__ == '__main__':
    debug = True
    main(debug)

